#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPX(op, t, x) operator op(CRP(t, x))
#define OPL(t, x) bool OPX(<, t, x) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef int64_t ll, i64;
typedef uint64_t ull, u64;
template <typename... Types>
using comtype = typename common_type<Types...>::type;
template <typename T>
using enable_if_arithmetic = typename enable_if<is_arithmetic<T>::value>::type;
template <typename T>
using enable_if_integral = typename enable_if<is_integral<T>::value>::type;
inline char getchar(int)
{
    static char buf[64 << 20], *S = buf, *T = buf;
    if (S == T) T = fread(S = buf, 1, 64 << 20, stdin) + buf;
    return S == T ? EOF : *S++;
}
template <typename T, typename = enable_if_integral<T>>
inline bool read(T &x)
{
    int ch = x = 0, f = 1;
    while (!isdigit(ch = getchar()))
        if (ch == EOF)
            return false;
        else if (ch == '-')
            f = 0;
    for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
    return x = f ? x : -x, true;
}
template <typename T, typename... Args, typename = enable_if_integral<T>>
inline bool read(T &x, Args &... args) { return read(x) && read(args...); }
template <typename T1, typename T2, typename TResult = comtype<T1, T2>>
inline TResult mmin(CRP(T1, v1), CRP(T2, v2)) { return min<TResult>(v1, v2); }
template <typename T, typename... Args, typename TResult = comtype<T, Args...>>
inline TResult mmin(CRP(T, v), const Args &... args) { return min<TResult>(v, mmin(args...)); }
template <typename T1, typename T2, typename TResult = comtype<T1, T2>>
inline TResult mmax(CRP(T1, v1), CRP(T2, v2)) { return max<TResult>(v1, v2); }
template <typename T, typename... Args, typename TResult = comtype<T, Args...>>
inline TResult mmax(CRP(T, v), const Args &... args) { return max<TResult>(v, mmax(args...)); }
ll gcd(ll a, ll b) { return b == 0 ? a : gcd(b, a % b); }
ll fpow(ll a, ll b, ll m)
{
    ll r = 1;
    for (; b; b >>= 1, a = a * a % m)
        if (b & 1) r = r * a % m;
    return r;
}
constexpr double eps = 1e-8;
inline int sgn(double x) { return x > eps ? 1 : x < -eps ? -1 : 0; }
const int N = 3e5 + 50;
ll a[N], b[N], dp[N][3];
int main()
{
    int q, n;
    read(q);
    while (q--)
    {
        read(n);
        for (int i = 0; i < n; i++) read(a[i]), read(b[i]);
        memset(dp, 0x3f, sizeof(ll) * 3 * (n + 10));
        dp[0][0] = 0;
        dp[0][1] = b[0];
        dp[0][2] = b[0] << 1;
        for (int i = 1; i < n; i++)
            for (int j = 0; j < 3; j++)
                for (int k = 0; k < 3; k++)
                    if (a[i - 1] + j != a[i] + k)
                        dp[i][k] = min(dp[i][k], dp[i - 1][j] + k * b[i]);
        printf("%lld\n", mmin(dp[n - 1][0], dp[n - 1][1], dp[n - 1][2]));
    }
    return 0;
}